.area _CODE

.include "cpctelera.h.s"
.include "hero.h.s"
;;.include "obstacle.h.s"
.include "map.h.s"
.include "utils.h.s"
.include "portals.h.s"
.include "constants.h.s"

.globl _sprite_oportal
.globl _sprite_dportal
.globl _sprite_obullet
.globl _sprite_dbullet
;;========================================
;; Private variables
;;========================================

defineEntity portalBullet, -1, -1, 1, 4, #_sprite_obullet, 0, 0

defineEntity portalIndicator, 78, 0, 1, 4, #_sprite_dbullet, 0, 0

;; move bullet select movement
portal_bullet_mv_x:  .db #0    ;; 0 not do nothing, 1 increment, -1 decerement
portal_bullet_mv_y:  .db #0
gun_portal_state:    .db #1    ;; 1 avaliable, -1 unvaliable
gun_portal_selected: .db #1   ;; -1 origen, 1 destiny
portal_bullet_dir:   .db #0    ;; indicate direction key pressed
portal_bullet_coll:  .db #0    ;; 0 (no collision) 1 (collision)

;;========================================
;; Public methods
;;========================================
gun_portal_draw::
  ld ix, #portalIndicator_data
  call utils_drawSprite
ret

gun_portal_erase::
  ld ix, #portalIndicator_data
  ld c, Ent_x(ix)
  ld b, Ent_y(ix)
  ld de, #0xC000
  call cpct_getScreenPtr_asm
  ex de, hl
  ld c, Ent_w(ix)
  ld b, Ent_h(ix)
  call cpct_drawSolidBox_asm
ret

;;==============================================
;; Check keys pressed by user
;;===========================================
gun_portal_update::
  ;; move bullet and choose portal
  ld a, (gun_portal_state)
  cp #-1                                ;; -1--1=0
  jr z, coll_bullet
  call check_user_input_choose_portal
  call check_user_input_choose_direction
  ret
  coll_bullet:
  ld a, #0
  ld (check_cube), a
  call bullet_check_collision
  ld a, #1
  ld (check_cube), a
  ;; erase bullet when it is collisioned with a wall (add when gun combinated with portal)
  ret

;;===============================================================
;; Draw blue the bullet
;;===============================================================
bullet_erase::
  ld ix, #portalBullet_data
  ld a, Ent_x(ix)
  cp #-1
  ret z         ;; bullet contain value -1 (not erase)
  ld c, a
  ld b, Ent_y(ix)

  ld de, #0xC000
  call cpct_getScreenPtr_asm
  ex de, hl
  ld a, #bg_color
  ld c, Ent_w(ix)
  ld b, Ent_h(ix)
  call cpct_drawSolidBox_asm

  ret

;;===============================================================
;; Draw red bullet when it is activated
;;===============================================================
bullet_draw::
  ld ix, #portalBullet_data
  ld a, Ent_x(ix)
  cp #-1
  ret z         ;; bullet contain value -1 (not draw)
  call utils_drawSprite
  ret

;;========================================
;; Private methods
;;========================================

;;=========================================================
;; checking the keys of keyboard for choosing direction
;; where portal will be generated
;;=========================================================
check_user_input_choose_direction:
 call cpct_scanKeyboard_asm

 key_i:                           ;; up, left-up, right-up
 ld hl, #Key_I                    ;; up
 call cpct_isKeyPressed_asm
 cp #0
 jr z, key_k
                                  ;;check  upper diagonal
     key_ij:
     ld hl, #Key_J                ;; left-up
     call cpct_isKeyPressed_asm
     cp #0
     jr z, key_il
     ld a, #Dir_IJ
     ld (portal_bullet_dir), a
     call stablish_portal
     ret

     key_il:
     ld hl, #Key_L                ;; right-up
     call cpct_isKeyPressed_asm
     cp #0
     jr z, key_up
     ld a, #Dir_IL
     ld (portal_bullet_dir), a
     call stablish_portal
     ret

     key_up:
     ld a, #Dir_I
     ld (portal_bullet_dir), a
     call stablish_portal
     ret

   key_k:                           ;; down, left-down, right-down
   ld hl, #Key_K                    ;; down
   call cpct_isKeyPressed_asm
   cp #0
   jr z, key_l
                                    ;;check  lower diagonal
       key_kj:
       ld hl, #Key_J                ;; down-left
       call cpct_isKeyPressed_asm
       cp #0
       jr z, key_kl
       ld a, #Dir_KJ
       ld (portal_bullet_dir), a
       call stablish_portal
       ret

       key_kl:
       ld hl, #Key_L                ;; down-left
       call cpct_isKeyPressed_asm
       cp #0
       jr z, key_down
       ld a, #Dir_KL
       ld (portal_bullet_dir), a
       call stablish_portal
       ret

       key_down:
       ld a, #Dir_K
       ld (portal_bullet_dir), a
       call stablish_portal
       ret

   key_l:
   ld hl, #Key_L                ;; right
   call cpct_isKeyPressed_asm
   cp #0
   jr z, key_j
   ld a, #Dir_L
   ld (portal_bullet_dir), a
   call stablish_portal
   ret

   key_j:
   ld hl, #Key_J                ;; left
   call cpct_isKeyPressed_asm
   cp #0
   ret z
   ld a, #Dir_J
   ld (portal_bullet_dir), a
   call stablish_portal
   ret

  check_user_input_choose_portal:
   call cpct_scanKeyboard_asm
   ;; Check portal choosed by user
   key_o:
   ld hl, #Key_O
   call cpct_isKeyPressed_asm
   cp #0
   jr z, key_p
   ld a, #1
   ld (gun_portal_selected), a
   ld hl, #_sprite_dbullet         ;; put sprite destiny
   call change_sprite_indicator
   ret
   key_p:
   ld hl, #Key_P
   call cpct_isKeyPressed_asm
   cp #0
   ret z
   ld a, #-1
   ld (gun_portal_selected), a
   ld hl, #_sprite_obullet         ;; put sprite origen
   call change_sprite_indicator
   ret



;;=========================================================
;; After choose the direction of bullet the hero have to
;; press another key for choose the portal (origin o destin)
;;=========================================================
 stablish_portal:
   ld a, #-1                       ;; portal unvaliable
   ld (gun_portal_state), a
   ld a, (gun_portal_selected)
   cp #1
   jr z, prt_dest
   ;; prt_org
   ;;gun_portal_selected -1
   call locate_bullet              ;; stablish bullet in same position heroe
   ld hl, #_sprite_obullet         ;; put sprite origen
   call change_sprite_bullet
   ret
   prt_dest:
   ;;gun_portal_selected 11
   call locate_bullet              ;; stablish bullet in same position heroe
   ld hl, #_sprite_dbullet         ;; put sprite destiny
   call change_sprite_bullet
   ret

;;========================================
;; Move bullet influenced by direction
;;========================================
bullet_move::
    ld ix, #portalBullet_data
    call utils_moveEntity
    ret

bullet_check_collision:
  ck_dir_l:
  ld a, (portal_bullet_dir)
  cp #Dir_L
  jr nz, ck_dir_il
  call bullet_move_right
  ret
  ck_dir_il:
  cp #Dir_IL
  jr nz, ck_dir_i
  call bullet_move_up_right
  ret
  ck_dir_i:
  cp #Dir_I
  jr nz, ck_dir_ij
  call bullet_move_up
  ret
  ck_dir_ij:
  cp #Dir_IJ
  jr nz, ck_dir_j
  call bullet_move_up_left
  ret
  ck_dir_j:
  cp #Dir_J
  jr nz, ck_dir_kj
  call bullet_move_left
  ret
  ck_dir_kj:
  cp #Dir_KJ
  jr nz, ck_dir_k
  call bullet_move_down_left
  ret
  ck_dir_k:
  cp #Dir_K
  jr nz, ck_dir_kl
  call bullet_move_down
  ret
  ck_dir_kl:
  cp #Dir_KL
  ret nz
  call bullet_move_down_right
  ret
;;=============================================================
;; When bullet goes out, or is collision with other object
;;=============================================================
hide_bullet:
  ld ix, #portalBullet_data

  ld b, a                       ;; B = orientation

  ld a, (tile_type)
  cp #NoPortal
  jr z, erase_bullet

  cp #Poison
  jr z, erase_bullet

  ld a, (gun_portal_selected)   ;; A = selected portal
  cp #1
  ld a, b
  jr z, org_portal

  blue_portal:
    call portals_setBluePortal
    jr erase_bullet
  org_portal:
    call portals_setOrangePortal

  erase_bullet:

  call bullet_erase

  ld a, #-1
  ld Ent_x(ix), a
  ld Ent_y(ix), a
  ld a, #1
  ld (gun_portal_state), a
  ret

;;=============================================================
;; Stablish the location portal, beacuse the bullets collision
;; with an object
;;=============================================================
;;locate_portal:
  ;;ld hl, #portalBullet_data
  ;;ld a, (gun_portal_selected)
  ;;cp #-1      ;; -1--1=0,
  ;;jr z, locate_origin
  ;; destiny
  ;;ld ix, #portalDestiny_data
  ;;call locate_portal_aux
  ;;ret
  ;;locate_origin:
  ;;ld ix, #portalOrigin_data
  ;;call locate_portal_aux
  ;;ret

;;=============================================================
;; INPUTS: hl => bullet_data, ix=>portal_data
;; x-w_bullet/2-w_hero/2
;; y-h_bullet/2-h_hero/2
;;=============================================================
  ;;locate_portal_aux:
    ;;ld a, (hl)            ;; points x
    ;;ld b, a
    ;;inc hl                ;; points y
    ;;inc hl                ;; points h
    ;;ld a, (hl)
    ;;add b
    ;;ld Ent_x(ix), a
    ;;dec hl
    ;;ld a, (hl)            ;; points y
    ;;ld Ent_y(ix), a
    ;;ret

;;=============================================================
;; Stablish the location bullet, for start the shoot
;;=============================================================
locate_bullet:
  call hero_getPtrHL
  ld ix, #portalBullet_data
                            ;; AXIS X
  ;; portalBullet_x = hero_x + hero_w/2 - portalBullet_w/2
  ld a, Ent_w(ix)           ;; A = bullet_w
  srl a                     ;; A = bullet_w/2
  ld b, a                   ;; B = bullet_w/2
  ld a, (hl)                ;; A = hero_x
  inc hl                    ;; hl points y
  inc hl                    ;; hl points w
  ld c, a                   ;; C = hero_x
  ld a, (hl)                ;; A = hero_w
  srl a                     ;; A = hero_w/2
  add c                     ;; A = hero_w/2 + hero_x
  sub b                     ;; A = hero_w/2 + hero_x - bullet_w/2
  ld Ent_x(ix), a           ;; bullet_x = hero_w + hero_x
                            ;; AXIS Y
  ;; portalBullet_x = hero_x + hero_w/2 - portalBullet_w/2
  ld a, Ent_h(ix)           ;; A = bullet_h
  srl a                     ;; A = bullet_h/2
  ld b, a                   ;; B = bullet_h/2
  dec hl                    ;; hl points hero_y
  ld a, (hl)                ;; A = hero_y
  ld c, a                   ;; C = hero_y
  inc hl                    ;; hl => hero_w
  inc hl                    ;; hl => hero_h
  ld a, (hl)                ;; A = hero_h
  srl a                     ;; A = hero_h/2
  add c                     ;; A = hero_h/2 + hero_y
  sub b                     ;; A = hero_h/2 + hero_y - bullet_h/2
  res 0, a                  ;; |
  res 1, a                  ;; \ Round to tile
  res 2, a
  ld Ent_y(ix), a           ;; bullet_y = hero_h/2 + hero_y - bullet_h/2

  ret


bullet_move_right:
  ld ix, #portalBullet_data
  ld a, #0
  ld Ent_vx(ix), a
  ld Ent_vy(ix), a
  call map_checkRightBounds       ;; A = 1 exist obstacle
  cp #1
  jr z, do_not_move_r
  inc Ent_vx(ix)              ;; Increments vx (moves right)
  ret
  do_not_move_r:
  ;;call locate_portal
  ld a, #Right
  call hide_bullet
  ret

bullet_move_left:
  ld ix, #portalBullet_data
  ld a, #0
  ld Ent_vx(ix), a
  ld Ent_vy(ix), a
  call map_checkLeftBounds        ;; A = 1 exist obstacle
  cp #1
  jr z, do_not_move_l
  dec Ent_vx(ix)              ;; Increments vx (moves right)
  ret
  do_not_move_l:
  ;;call locate_portal
  ld a, #Left
  call hide_bullet
  ret

bullet_move_up:
  ld ix, #portalBullet_data
  ld a, #0
  ld Ent_vx(ix), a
  ld Ent_vy(ix), a
  call map_checkUpperBounds        ;; A = 1 exist obstacle
  cp #1
  jr z, do_not_move_u
  ld Ent_vy(ix), #-4
  ret
  do_not_move_u:
  ;;call locate_portal
  ld a, #Up
  call hide_bullet
  ret

bullet_move_down:
  ld ix, #portalBullet_data
  ld a, #0
  ld Ent_vx(ix), a
  ld Ent_vy(ix), a
  call map_checkLowerBounds        ;; A = 1 exist obstacle
  cp #1
  jr z, do_not_move_d
  ld Ent_vy(ix), #4
  ret
  do_not_move_d:
  ;;call locate_portal
  ld a, #Down
  call hide_bullet
  ret

bullet_move_up_right:
  ld ix, #portalBullet_data
  ld a, #0
  ld Ent_vx(ix), a
  ld Ent_vy(ix), a
  call map_checkRightBounds       ;; A = 1 exist obstacle
  cp #1
  jp z, do_not_move_r
  call map_checkUpperBounds       ;; A = 1 exist obstacle
  cp #1
  jp z, do_not_move_u
  ld Ent_vy(ix), #-4
  inc Ent_vx(ix)
  ret

bullet_move_up_left:
  ld ix, #portalBullet_data
  ld a, #0
  ld Ent_vx(ix), a
  ld Ent_vy(ix), a
  call map_checkLeftBounds       ;; A = 1 exist obstacle
  cp #1
  jp z, do_not_move_l
  call map_checkUpperBounds       ;; A = 1 exist obstacle
  cp #1
  jp z, do_not_move_u
  ld Ent_vy(ix), #-4
  dec Ent_vx(ix)
  ret

bullet_move_down_left:
  ld ix, #portalBullet_data
  ld a, #0
  ld Ent_vx(ix), a
  ld Ent_vy(ix), a
  call map_checkLeftBounds       ;; A = 1 exist obstacle
  cp #1
  jp z, do_not_move_l
  call map_checkLowerBounds       ;; A = 1 exist obstacle
  cp #1
  jp z, do_not_move_d
  ld Ent_vy(ix), #4
  dec Ent_vx(ix)
  ret

bullet_move_down_right:
  ld ix, #portalBullet_data
  ld a, #0
  ld Ent_vx(ix), a
  ld Ent_vy(ix), a
  call map_checkRightBounds       ;; A = 1 exist obstacle
  cp #1
  jp z, do_not_move_r
  call map_checkLowerBounds       ;; A = 1 exist obstacle
  cp #1
  jp z, do_not_move_d
  ld Ent_vy(ix), #4
  inc Ent_vx(ix)
  ret

;;========================================
;; INPUT: HL address sprite
;;========================================
change_sprite_bullet:
  ld    ix, #portalBullet_data
  ld    Ent_spr_l(ix), l
  ld    Ent_spr_h(ix), h
  ret

;;========================================
;; INPUT: HL address sprite
;;========================================
change_sprite_indicator:
  ld    ix, #portalIndicator_data
  ld    Ent_spr_l(ix), l
  ld    Ent_spr_h(ix), h
  ret
