.area _CODE

.globl _map1                  ;;  First map to use
.globl _map3                  ;;  Third map to use
.globl _map4
.globl _map5
.globl _map6
.globl _map7
.globl _map8
.globl _map9
.globl _map10
.globl _map11
.globl _map12

.globl reset_game
.globl _print_stats

.include "cpctelera.h.s"
.include "utils.h.s"
.include "constants.h.s"
.include "cake.h.s"

.include "map.h.s"

.include "hero.h.s"

.include "pellet_receptor.h.s"
.include "pellet.h.s"                      ;; Energy ball

.include "door.h.s"
.include "indicator.h.s"
.include "groundButton.h.s"

.include "cube_gravity.h.s"                    ;; get pointer de values position obstacle
.include "gun_portal.h.s"
.include "gun_gravity.h.s"
.include "portals.h.s"

level_timer:: .dw 0x0000
level_dtimer:: .dw 0x0000
level_attempts:: .dw 0x0000


end_text:
  .ascii "Congratulations!!!! "
  .ascii "                    "
  .ascii "You finished the    "
  .ascii "                    "
  .ascii "game.\0"

intro1:
  ;;      Line extension:
  ;;      ====================
  .ascii "Level 1             "
  .ascii "                    "
  .ascii "Ohh... uh...  What  "
  .ascii "                    "
  .ascii "am I doing here?    "
  .ascii "                    "
  .ascii "I remember. My name "
  .ascii "                    "
  .ascii "was... Selena?      "
  .ascii "                    "
  .ascii "I think with this   "
  .ascii "                    "
  .ascii "gun I can create    "
  .ascii "                    "
  .ascii "tunnels. I hope I   "
  .ascii "                    "
  .ascii "can scape with it...\0"

intro3:
  ;;      Line extension:
  ;;      ====================
  .ascii "Level 2             "
  .ascii "                    "
  .ascii "That ball and that  "
  .ascii "                    "
  .ascii "floor seem dan-     "
  .ascii "                    "
  .ascii "gerous...\0"
  
intro4:
  ;;      Line extension:
  ;;      ====================
  .ascii "Level 3             "
  .ascii "                    "
  .ascii "That code Selena    "
  .ascii "                    "
  .ascii "told me... can I    "
  .ascii "                    "
  .ascii "remember?\0"

intro5:
  ;;      Line extension:
  ;;      ====================
  .ascii "Level 4\0"

intro6:
  ;;      Line extension:
  ;;      ====================
  .ascii "Level 5\0"

intro7:
  ;;      Line extension:
  ;;      ====================
  .ascii "Level 6\0"

intro8:
  ;;      Line extension:
  ;;      ====================
  .ascii "Level 7\0"

intro9:
  ;;      Line extension:
  ;;      ====================
  .ascii "Level 8\0"

intro10:
  ;;      Line extension:
  ;;      ====================
  .ascii "Level 9\0"

intro11:
  ;;      Line extension:
  ;;      ====================
  .ascii "Level 10\0"

intro12:
  ;;      Line extension:
  ;;      ====================
  .ascii "Level 11\0"

;; ==============================================
;; ==============================================
;; PUBLIC PART
;; ==============================================
;; ==============================================

game_over::
    .db 0

current_level::
    .db #01          ;; Initialize at first level

levelManager_gameOver::
    ld a, #1
    ld (game_over), a
    ret
;;
;; Sets current_level to the next one
levelManager_nextLevel::
    ld a, (current_level)
    inc a
    ld (current_level), a
    ld a, #1
    ld (game_over), a
    ;; ld hl, #0
    ;; ld (level_attempts), hl
    ;; ld (level_timer), hl
    ;; ld (level_dtimer), hl
    ret

;;
;; Sets the level to its initial situation
;;  and draws it
levelManager_startLevel::
    ld a, #0            ;; |
    ld (game_over), a   ;; \ Set game_over to False
    call uninitialize_all
    ld a, (current_level)
    cp #1
    jr nz, l2
        call set_level1
        ret
    l2:
    cp #2
    jr nz, l3
        push hl
        ld hl, #current_level
        inc (hl)
        ld a, (hl)
        pop hl
        ;; call set_level2
        jr l3
        ret
    l3:
    cp #3
    jr nz, l4
        call set_level3
        ret
    l4:
    cp #4
    jr nz, l5
        call set_level4
        ret
    l5:
    cp #5
    jr nz, l6
        call set_level5
        ret
    l6:
    cp #6
    jr nz, l7
        call set_level6
        ret
    l7:
    cp #7
    jr nz, l8
        call set_level7
        ret
    ret
    l8:
    cp #8
    jr nz, l9
        call set_level8
        ret
    ret
    l9:
    cp #9
    jr nz, l10
        call set_level9
        ret
    l10:
    cp #10
    jr nz, l11
        call set_level10
        ret
    l11:
    cp #11
    jr nz, l12
        call set_level11
        ret
    l12:
    cp #12
    jr nz, end
        call set_level12
        ret

    end:
    ld a, #1
    ld (reset_game), a

    ld hl, #end_text
    call utils_print

    ret


levelManager_update::
    call cpct_scanKeyboard_asm 
                               
    ld hl, #Key_Esc
    call cpct_isKeyPressed_asm 
    cp #0
    jr z, no_reset
        ld a, #1
        ld (reset_game), a
        ret
    no_reset:

    ld a, (game_over)
    cp #1
    ret nz

    call levelManager_startLevel

    ld hl, (level_attempts)
    push hl
    call _print_stats
    pop hl
    ret

;;
;; Sets current_level
levelManager_setLevel::
    ld (current_level), a
    ret

;; ==============================================
;; ==============================================
;; PRIVATE PART
;; ==============================================
;; ==============================================

uninitialize_all:
    call groundButton_uninitialize
    call indicator_uninitialize
    call door_uninitialize
    call pellet_uninitialize
    call pelletReceptor_uninitialize
    call portals_uninitialize
    call cube_gravity_uninitialize
    call hero_uninitialize
    ret


set_level1:
    ld hl, #intro1
    call utils_print

    ld hl, #_map1
    ld (current_map), hl
    call map_printLevel

    ;; Initialize all stuff
    ld a, #01
    ld (NUMBER_OF_DOORS), a
    ld (NUMBER_OF_GRNDBTTNS), a

    set_pos grndButton_1_data, 12, 183

    set_pos dr_1_data, 68, 152
    ;;set_pos ind_1_data, 10, 42

    set_pos hero_data, 5, 140
    set_pos cake_data, 70, 176
    set_pos cube_gravity_data, 35, 176
    ret

set_level2:
    ;;ld hl, #_map2
    ;;ld (current_map), hl
    ;;call map_printLevel

    ;; Initialize all stuff
    ;;ld a, #01
    ;;ld (NUMBER_OF_PELLETS), a

    ;;set_pos plt_1_data, 39, 20
    ;;set_vel_ix 0, 4
    ;;ld ix, #plt_1_data
    ;;ld Ent_pltState(ix), #01  ;;NEEDED FOR ACTIVATING THE PELLET IN A LEVEL
    ;;set_pos hero_data, 10, 140
    ;;set_pos cube_gravity_data, 72, 36
    ;set_pos cake_data, 71, 176

    ret

set_level3:
  ld hl, #intro3
  call utils_print

    ld hl, #_map3
    ld (current_map), hl
    call map_printLevel

    ;; Initialize all stuff
    ld a, #02
    ld (NUMBER_OF_DOORS), a
    ld (NUMBER_OF_GRNDBTTNS), a
    ld a, #01
    ld (NUMBER_OF_PELLETS), a

    set_pos grndButton_1_data, 36, 143
    set_pos grndButton_2_data, 66, 87

    set_pos dr_1_data, 64, 64
    set_pos dr_2_data, 24, 40

    set_pos plt_1_data, 20,68
    set_vel_ix 1, 0
    ld ix, #plt_1_data
    ld Ent_pltState(ix), #01  ;;NEEDED FOR ACTIVATING THE PELLET IN A LEVEL

    set_pos hero_data, 44, 120
    set_pos cube_gravity_data, 50, 120
    set_pos cake_data, 27, 20
    ret

set_level4:
  ld hl, #intro4
  call utils_print

  ld hl, #_map4
  ld (current_map), hl
  call map_printLevel

  ;; Initialize all stuff

  ld a, #01
  ld (NUMBER_OF_DOORS), a
  ld (NUMBER_OF_PELLETS), a
  ld a, #02
  ld (NUMBER_OF_PLTRECEPTORS), a

  set_pos dr_1_data, 68, 160

  set_pos plt_1_data, 39, 20
  set_vel_ix 0, 4
  ld ix, #plt_1_data
  ld Ent_pltState(ix), #01  ;;NEEDED FOR ACTIVATING THE PELLET IN A LEVEL

  set_pos pltRecept_1_data, 72, 40
  set_pos pltRecept_2_data, 6, 100

  set_pos hero_data, 10, 140
  set_pos cube_gravity_data, 14, 140
  set_pos cake_data, 71, 176
  ret

set_level5:
  ld hl, #intro5
  call utils_print

  ld hl, #_map5
  ld (current_map), hl
  call map_printLevel

  ;; Initialize all stuff

  ld a, #02
  ld (NUMBER_OF_DOORS), a
  ld (NUMBER_OF_PLTRECEPTORS), a
  ld a, #01
  ld (NUMBER_OF_GRNDBTTNS), a
  ld (NUMBER_OF_PELLETS), a

  set_pos plt_1_data, 40, 174
  set_vel_ix 1, 0
  ld ix, #plt_1_data
  ld Ent_pltState(ix), #01  ;;NEEDED FOR ACTIVATING THE PELLET IN A LEVEL

  set_pos dr_2_data, 36, 156
  set_pos dr_1_data, 68, 160
  set_pos grndButton_2_data, 38, 95

  set_pos pltRecept_1_data, 25, 16
  set_pos pltRecept_2_data, 55, 16

  set_pos hero_data, 10, 12
  set_pos cube_gravity_data, 70, 40
  set_pos cake_data, 71, 174
  ret


set_level6:
  ld hl, #intro6
  call utils_print

  ld hl, #_map6
  ld (current_map), hl
  call map_printLevel

  ;; Initialize all stuff

  ld a, #02
  ld (NUMBER_OF_DOORS), a
  ld (NUMBER_OF_PELLETS), a
  ld a, #04
  ld (NUMBER_OF_PLTRECEPTORS), a

  set_pos plt_1_data, 40, 76
  set_vel_ix 1, 0
  ld ix, #plt_1_data
  ld Ent_pltState(ix), #01  ;;NEEDED FOR ACTIVATING THE PELLET IN A LEVEL

  set_pos plt_2_data, 39, 120
  set_vel_ix 0, 4
  ld ix, #plt_2_data
  ld Ent_pltState(ix), #01  ;;NEEDED FOR ACTIVATING THE PELLET IN A LEVEL


  set_pos dr_1_data, 36, 152
  set_pos dr_2_data, 36, 164


  set_pos pltRecept_1_data, 10, 30
  set_pos pltRecept_2_data, 65, 30
  set_pos pltRecept_3_data, 10, 140
  set_pos pltRecept_4_data, 65, 140

  set_pos hero_data, 32, 140
  set_pos cube_gravity_data, 70, 160
  set_pos cake_data, 39, 176
  ret

set_level7:
  ld hl, #intro7
  call utils_print

  ld hl, #_map7
  ld (current_map), hl
  call map_printLevel

  ;; Initialize all stuff

  ld a, #04
  ld (NUMBER_OF_DOORS), a
  ld a, #02
  ld (NUMBER_OF_GRNDBTTNS), a
  ld (NUMBER_OF_PLTRECEPTORS), a

  ld a, #01
  ld (NUMBER_OF_PELLETS), a

  set_pos plt_1_data, 40, 178
  set_vel_ix 1, 0
  ld Ent_pltState(ix), #01  ;;NEEDED FOR ACTIVATING THE PELLET IN A LEVEL

  set_pos grndButton_2_data, 70, 91
  set_pos grndButton_3_data, 50, 91

  set_pos dr_1_data, 12, 32
  set_pos dr_2_data, 30, 178
  set_pos dr_3_data, 52, 178

  set_pos pltRecept_1_data, 10, 176
  ld ix, #pltRecept_1_data
  ld hl, #dr_1_data
  ld Ent_pltRecpDoor_h(ix),h
  ld Ent_pltRecpDoor_l(ix),l

  set_pos pltRecept_2_data, 67, 176
  ld ix, #pltRecept_2_data
  ld hl, #dr_3_data
  ld Ent_pltRecpDoor_h(ix),h
  ld Ent_pltRecpDoor_l(ix),l

  set_pos hero_data, 6, 120
  set_pos cube_gravity_data, 12, 40
  set_pos cake_data, 16, 22
  ret

set_level8:
  ld hl, #intro8
  call utils_print

  ld hl, #_map8
  ld (current_map), hl
  call map_printLevel

  ;; Initialize all stuff
  ld a, #02
  ld (NUMBER_OF_DOORS), a
  ld (NUMBER_OF_GRNDBTTNS), a
  ld (NUMBER_OF_PELLETS), a
;;  ld (NUMBER_OF_PLTRECEPTORS), a

  set_pos dr_1_data, 70, 52
  set_pos dr_2_data, 70, 100

  set_pos grndButton_1_data, 3, 179
  set_pos grndButton_2_data, 20, 179

  set_pos plt_1_data, 60, 100
  ld ix, #plt_1_data
  set_vel_ix -1, 0
  ld Ent_pltState(ix), #01  ;;NEEDED FOR ACTIVATING THE PELLET IN A LEVEL

  set_pos hero_data, 8, 160
  set_pos cube_gravity_data, 13, 170
  set_pos cake_data, 33, 170
  ret

set_level9:
    ld hl, #intro9
    call utils_print

    ld hl, #_map9
    ld (current_map), hl
    call map_printLevel

    ;; Initialize all stuff
    ld a, #02
    ld (NUMBER_OF_DOORS), a
    ld (NUMBER_OF_GRNDBTTNS), a

    set_pos dr_1_data, 22, 40

    set_pos grndButton_1_data, 10, 167

    set_pos hero_data, 70, 120
    set_pos cube_gravity_data, 44, 24
    set_pos cake_data, 12, 24
    ret

set_level10:
    ld hl, #intro10
    call utils_print

    ld hl, #_map10
    ld (current_map), hl
    call map_printLevel

    ;; Initialize all stuff
    ld a, #02
    ld (NUMBER_OF_DOORS), a
    ld (NUMBER_OF_GRNDBTTNS), a
    ld (NUMBER_OF_PELLETS), a
    ld (NUMBER_OF_PLTRECEPTORS), a

    set_pos dr_1_data, 64, 168
    set_pos dr_2_data, 4, 40

    set_pos plt_1_data, 40, 20
    set_vel_ix 1, 0

    ld ix, #plt_1_data
    ld Ent_pltState(ix), #01  ;;NEEDED FOR ACTIVATING THE PELLET IN A LEVEL

    ;set_pos plt_2_data, 20, 44
    ;set_vel_ix 1, 0

    ;ld ix, #plt_2_data
    ;ld Ent_pltState(ix), #01  ;;NEEDED FOR ACTIVATING THE PELLET IN A LEVEL


    set_pos pltRecept_2_data, 40, 48

    set_pos grndButton_1_data, 6, 63

    set_pos hero_data, 30, 160
    set_pos cube_gravity_data, 45, 140
    set_pos cake_data, 68, 45
    ret

set_level11:
  ld hl, #intro11
  call utils_print

  ld hl, #_map11
  ld (current_map), hl
  call map_printLevel

  ;; Initialize all stuff
  ld a, #01
  ld (NUMBER_OF_DOORS), a
  ld (NUMBER_OF_GRNDBTTNS), a
  ld a, #02
  ld (NUMBER_OF_PELLETS), a

  set_pos dr_1_data, 4, 48

  set_pos plt_1_data, 50, 64
  set_vel_ix 1, 0
  ld ix, #plt_1_data
  ld Ent_pltState(ix), #01  ;;NEEDED FOR ACTIVATING THE PELLET IN A LEVEL

  set_pos plt_2_data, 54, 120
  set_vel_ix 1, 0
  ld ix, #plt_2_data
  ld Ent_pltState(ix), #01  ;;NEEDED FOR ACTIVATING THE PELLET IN A LEVEL


  set_pos grndButton_1_data, 12, 75

  set_pos hero_data, 4, 120
  set_pos cube_gravity_data, 50, 144
  set_pos cake_data, 7, 20
  ret

set_level12:
  ld hl, #intro12
  call utils_print

    ld hl, #_map12
    ld (current_map), hl
    call map_printLevel

    ;; Initialize all stuff
    set_pos hero_data, 8, 148

    set_pos grndButton_1_data, 12, 183
    set_pos dr_1_data, 4, 116

    set_pos grndButton_2_data, 6, 79
    set_pos dr_2_data, 64, 76

    set_pos cube_gravity_data, 56, 148

    ld a, #01
    ld (NUMBER_OF_PELLETS), a
    ;; set_pos plt_2_data, 24, 64
    ;; set_vel_ix -4, 0

    set_pos plt_1_data, 56, 172
    set_vel_ix -4, 0
    ld ix, #plt_1_data
    ld Ent_pltState(ix), #01  ;;NEEDED FOR ACTIVATING THE PELLET IN A LEVEL

    set_pos cake_data, 50, 128

    ret


initializeEntities:
  call groundButton_initialize
  call indicator_initialize
  call door_initialize
  call pelletReceptor_initialize
  ret
