.area _CODE

.include "cpctelera.h.s"
.include "hero.h.s"
.include "gun_portal.h.s"
.include "utils.h.s"
.include "map.h.s"
.include "constants.h.s"
.include "portals.h.s"
.globl _sprite_cube

;;========================================
;; Private data
;;========================================

cube_gravity_state::     .db #-1            ;; -1 (cube moves free), 1 (cube moved by gravity gun)
cube_gravity_sense:     .db #1             ;; 1 (move right), -1 (move left)

cube_fall: .db #-1
cube_hold: .db #0

;; defineEntity cube_gravity, 50, 176, 2, 8, #_sprite_cube, 0, 0
defineEntity cube_gravity, -1, -1, 2, 8, #_sprite_cube, 0, 0
defineEntity erase_cube, -1, -1, 2, 8, 0, 0, 0

;; NUMBER_OF_CUBES:: .db #01

;;========================================
;; Public function
;;========================================

cube_gravity_uninitialize::
  set_pos cube_gravity_data, -1, -1
  set_pos erase_cube_data, -1, -1
  ;; ld a, #-1
  ;; ld (cube_gravity_state), a
  ret

cube_gravity_draw::
  ld ix, #cube_gravity_data

  ld a, Ent_x(ix)
  inc a
  ret z

  jp utils_drawSprite

cube_gravity_erase::
  ld ix, #erase_cube_data

  ld a, Ent_x(ix)
  inc a
  jr nz, erase_aux_cube

  ld ix, #cube_gravity_data

  ld a, Ent_x(ix)
  inc a
  ret z

  erase_aux_cube:

  ld c, Ent_x(ix)
  ld b, Ent_y(ix)
  ld de, #0xC000
  call cpct_getScreenPtr_asm
  ex de, hl
  ld a, #bg_color
  ld c, Ent_w(ix)
  ld b, Ent_h(ix)
  jp cpct_drawSolidBox_asm
  
cube_gravity_update::
  ld ix, #cube_gravity_data
  ld Ent_vy(ix), #0               ;; \ Ent_vel set up to 0

  ld a, Ent_x(ix)
  inc a
  ret z

  ld a, (cube_gravity_state)
  inc a
  jr z, mv_free
  ld iy, #erase_cube_data
  ld a, Ent_x(ix)
  ld Ent_x(iy), a
  ld a, Ent_y(ix)
  ld Ent_y(iy), a
  jp cube_gravity_follow_hero     ;; obstacle_state = 1
  mv_free:
  ;; call cube_gravity_erase
  call cube_gravity_fall
  set_pos erase_cube_data, -1, -1
  ld ix, #cube_gravity_data
  jp portals_crossIfInside

cube_gravity_move::
  ld ix, #cube_gravity_data

  ld a, Ent_x(ix)
  inc a
  ret z

  ld ix, #cube_gravity_data
  jp utils_moveEntity

cube_gravity_isCollision::
  ld de, #cube_gravity_data
  call  utils_checkCollision  ;;  Check if collide entity and pellet_1
  ret z
  ld a, #1
  ret
;;=============================================================
;; Sense 1 move right, until exist solid change sense to left
;; Sense 0 move left, until exist solid change sense to right
;;============================================================
  move_free:
  ld a, (cube_gravity_sense)
  inc a
  jr z, mvl
  ;; mvr: sense 1 go right
  ld ix, #cube_gravity_data
  call map_checkRightBounds
  dec a
  jr z, cmvl
  ;; continue mv right
  ld a, #1
  ld ix, #cube_gravity_data
  ld Ent_vx(ix), a
  ret
  cmvl:                     ;; change move left
  ld a, #-1
  ld ix, #cube_gravity_data
  ld Ent_vx(ix), a
  ld (cube_gravity_sense), a    ;; cube_sense = -1 (go left)
  ret
  mvl:
  ld ix, #cube_gravity_data
  call map_checkLeftBounds
  dec a
  jr z, cmvr
  ;; continue mv left
  ld a, #-1
  ld ix, #cube_gravity_data
  ld Ent_vx(ix), a
  ret
  cmvr:                     ;; change move right
  ld a, #1
  ld ix, #cube_gravity_data
  ld Ent_vx(ix), a
  ld (cube_gravity_sense), a    ;; cube_gravity_sense = 1 (go right)
  ret

;;========================================
;; Update constantly
;; -1 free
;; 1 move like hero
;; INPUT hl
;;========================================
  cube_gravity_follow_hero:
    ld hl, #hero_data
    ld a, (hero_sense)          ;; get sense movement hero
    ld ix, #cube_gravity_data
    ;;ld a, (hl)                ;; hl points hero_x => a
    ;;ld Ent_x(ix), a           ;; cube_gravity_x = hero_x
    ;;inc hl                    ;; hl points hero_y => a
    ;;ld a, (hl)
    ;;ld Ent_y(ix), a
    dec a
    jr nz, cube_gravity_follow_hero_left
	;bug in original ?
    ;call cube_gravity_follow_hero_right
    ;jp cube_gravity_follow_hero_left
    ;locate_sense_r:
    ;jp cube_gravity_follow_hero_right
    
;;========================================
;; INPUTS: hl (hero), ix (obstacle)
;; Locate obstacle in right side hero
;;========================================
  cube_gravity_follow_hero_right:
   ;; cube_gravity_x = hero_x + hero_h, cube_gravity_y = hero_y/2
   ld a, (hl)               ;; A = hero_x, hl points hero_x
   ;ld b, a                  ;; B = hero_x
   inc hl                   ;; hl points hero_y
   inc hl                   ;; hl points hero_w
   ;; ld a, (hl)               ;; A = hero_w
   ;; add b                    ;; A = hero_w + hero_x
   ld Ent_x(ix), a          ;; cube_gravity = hero_h + hero_x
   dec hl                   ;; hl points hero_y
   ld a, (hl)               ;; A = hero_y
   ;;srl a                    ;; A = hero_y/2
   ld Ent_y(ix), a          ;; cube_gravity_y = hero_y
   ret

 ;;========================================
 ;; INPUTS: hl (hero), ix (obstacle)
 ;; Locate obstacle in left side hero
 ;;========================================
   cube_gravity_follow_hero_left:
   ;; cube_gravityx = hero_x + cube_gravity_h, cube_gravity_y = hero_y/2
    ld a, Ent_w(ix)          ;; A = cube_gravity_h
    ;ld b, a                  ;; B = cube_gravity_h
    ;; ld a, (hl)               ;; A = hero_x, hl points hero_x
    ;; sub b                    ;; A = hero_x - cube_gravity_h
    ld Ent_x(ix), a          ;; cube_gravity_x = hero_h + hero_x
    inc hl                   ;; hl points hero_y
    ld a, (hl)               ;; A = hero_y
    ;;srl a                    ;; A = hero_y/2
    ld Ent_y(ix), a          ;; cube_gravity_y = hero_y
    ret

cube_gravity_fall:
  ld ix, #cube_gravity_data       ;; ix = *hero_data

  ;; ld a, Ent_x(ix)
  ;; add Ent_vx(ix)
  ;; ld Ent_x(ix), a
  call map_checkLowerBounds
  ;; push af
  ;;
  ;; ld ix, #cube_gravity_data
  ;; ld a, Ent_x(ix)
  ;; sub Ent_vx(ix)
  ;; ld Ent_x(ix), a
  ;;
  ;; pop af
  cp #1

  jr z, cube_not_fall

  ;; check collision with the cube_gravity
  ;;ld hl, #hero_data
  ;;call cube_gravity_getPtrDE
  ;;call utils_checkCollision
  ;;cp #00
  ;;jp nz, finish_jump

  ;; Get Fall Value
  ld a, (cube_fall)               ;; Loads to A the index of current fall
  cp #-1                          ;; |
  jr nz, cube_already_falling     ;; \ If hero_fall == -1, set to 0

    sub a                   ;; |
    ld (cube_fall), a       ;; \ hero_fall = 0

  cube_already_falling:
  ;; inc a                   ;; Increases the index in A
  ld hl, #falltable           ;; HL points to start of fall
  ld c, a                     ;; |
  ld b, #0                    ;; \ BC = A (offset)
  add hl, bc                  ;; HL += BC
  ld a, (hl)                  ;; A = fall[hero_fall]
  cp a, #80                   ;; |
  ld a, #4
  jr z, last_cube_fall_pos    ;; \ If A is not last value, increase fall vel

  ld a, (cube_fall)
  inc a
  ld (cube_fall), a

  ld c, a                     ;; Load the fall index of A in C
  ld b, #0                    ;; BC = A(offset)
  ld hl, #falltable           ;; HL -> *pushtable
  ld a, (hl)                  ;; A = fall[hero_fall]

  ;; dec a                    ;; Decreases the index in A

  last_cube_fall_pos:
  ;; ld (hero_fall), a        ;; Save the the hero_fall

  ld ix, #cube_gravity_data
  srl Ent_y(ix)
  srl Ent_y(ix)
  sla Ent_y(ix)
  sla Ent_y(ix)
  ld Ent_vy(ix), a            ;; loads fall value in vel_y

  ret

  cube_not_fall:
    ;; ld ix, #cube_gravity_data
    ld hl, #cube_fall       ;; |

    ld (hl), #-1            ;; \ Set hero_fall variable to -1 (not falling)
  ret                     ;; And return
